;lcdtest.a51*******zum Projekt gehrt noch die Datei lcd8252.a51 ***********************
;***************************************************************************************
;******** Testprogramm: Aufwrtszhler sichtbar an 8LEDs und als Hexziffer im LC-Display
;***************************************************************************************

		include C51rd2.pdf	;Registeradressen einbinden
		
;******************* Unterprogramme in der Datei lcd8252.a51 ***************************
EXTERN CODE initLCD,loeschzeile1,loeschzeile2,textzeile1,textzeile2,cursorpos
EXTERN CODE textaus,zifferaus,hexaus,dezaus		
		; auch mglich EXTRN CODE (   ,    ,    ) wie fr Keil-A51 ntig

;******************** Deklarationen ****************************************************
		LCDPosHex	EQU 0Eh	;Position der Hex-Zahl im Display
		LCDPosDez	EQU 4Dh	;Position der Dez-Zahl im Display
		LEDs		DATA p2	;LEDs an P2
	
;******************** Programm *********************************************************
      	
      	code at 0			;Programmbeginn, auch mglich: cseg at 0
      	
init:  	mov   sp,#2fh		;Stackpointer oberhalb Bitadressierbarer Bereich
	
		lcall	initlcd		;Display initialisieren
		lcall	loeschzeile1	;Lschen
		lcall	loeschzeile2

		mov   dptr,#Text1		;Text 
		lcall	textzeile1		;in Zeile 1 ausgeben
		mov   dptr,#Text2		;Text
		lcall textzeile2		;in Zeile 2 ausgeben
	
		mov 	r2,#0			;Anfangswert Zhler			
zeit:		djnz  r0,zeit		;Zeitverzgerung;
		djnz  r1,zeit
		inc   r2			;Zhlerstand erhhen
		mov   LEDs,r2		;an LEDs ausgeben

		mov   a,#LCDPosHex	;Cursor-Position fr Hexzahl
		lcall cursorpos		;an LCD ausgeben
		mov   a,r2			;Zhlerstand 
;		lcall zifferaus		;mit nur einer Ziffer (Lownibbel) ausgeben  an LCD
		lcall	hexaus		;als 2-stellige Hexzahl ausgeben an LCD

		mov   a,#LCDPosDez	;Cursor-Position fr Dezimalzahl
		lcall cursorpos		;an LCD ausgeben
		mov   a,r2			;Zhlerstand
		lcall dezaus		;ausgeben
		sjmp  zeit			;von vorne

;************************ Texte *******************************************************
Text1:	db 'Hexzahl    :',0
Text2:	db 'Dezimalzahl:',0

END








